/*
   3D Invaders

   invader.h

   (c)2002 Paul Boese
*/

#ifndef __INVADER_H
#define __INVADER_H

#include "common.h"

#define MAX_HITS 5

typedef struct {
	float u;
	float v;
} uv_t;

class Invader;

class Invader {
	private:
		int mode;

		static int sfx_fall;
		static int refcnt;
		
		int hits;
		float distance;
		float velocity;
		float rotx, roty, rotz;
		int roti;
		int explode;
		point_t position;
		point_t direction;

		static PR_nurb * s1, * nrbR, * nrbs;
		static Ppoint4 *pts;
		static uv_t * uvs;
		static int nx, ny;
		void make_nurbs();
		void draw_invader();
		void draw_active();
		int draw_falling();

		static void sfxinit() {
			if (!refcnt) {
				sfx_fall = snd_sfx_load("/rd/shot.wav");
			}
		}

	public:
		Invader();

		point_t * Pos() {
			return &position;
		}

		void Hit(); // Hit and falls to oblivian

		void Poof(); // Hit but instantly blown away

		int Active();

		void Reset();

		void Draw(point_t * pos);
};

#endif /* __INVADER_H */
